using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using UnityEngine;
using System.Collections;
using UnityEngine.Events;

namespace WWII
{
    public class WWII
    {
        public static void Main()
        {
          CategoryBuilder.Create("WWII <color=yellow>Pistols</color>", "Pistols from the WW2 Age.", ModAPI.LoadSprite("categoryicon.png"));


          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Browning HP <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "One of the few pistols of that war thought of holding more than 8 rounds. Or is it psychology: fewer cartridges - less desire to spend them? \n<color=yellow>Ammo: 13/130",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/browning icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/browning_hp_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/browning_hp_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/browning_hp_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/browning_hp.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 13;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/browning_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.15f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/browning_hp sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.45f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.45f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
                        Ammo.FireRate = 0.0001f;
                        Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.45f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.084f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Colt M1911 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Good old Colt (within the framework of a seven-shot weapon). \n<color=yellow>Ammo: 7/140",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/m1911 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/m1911_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/m1911_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/m1911_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/m1911.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/m1911_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.13f, 0.06f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/m1911 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".45 ACP";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.7f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.7f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.115f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "M1942 Liberator <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Created to support resistance formations, but in fact a weapon for suicide bombers with manual juggling of a long bolt. The cheapest pistol in the world. \n<color=yellow>Ammo: 5/10",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/liberator icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/liberator_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/liberator_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/liberator_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/liberator.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 5;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/liberator_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.01f, 0.05f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/liberator sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.85f;
                      customCartridge.ImpactForce = 0.7f;
                      customCartridge.StartSpeed = 3f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.85f;
                        customCartridge.ImpactForce = 0.7f;
                        customCartridge.StartSpeed = 3f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 1s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");
                        Ammo.FireRate = 1f;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.85f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.045f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "PB Baltiez <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "It was supposed to replace the TT in the cold season, but with the help of it they discovered the theft at the plant and put several people in the Soviet Gulag. \n<color=yellow>Ammo: 8/120",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/pb icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/pb_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/pb_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/pb_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/pb.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/pb_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.17f, 0.10f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/pb sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62x25mm TT";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.57f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.57f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.096f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "TK Korovin <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "The first Soviet serial self-loading pistol. \n<color=yellow>Ammo: 8/120",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/tk icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/tk_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/tk_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/tk_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/tk.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/tk_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.11f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/tk sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "6,35x15mm Browning";
                      customCartridge.Damage = 8.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.47f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 8.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.47f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.048f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Tokarev TT <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A high-powered pistol of the Soviet army capable of piercing a steel helmet (idk like in the game). \n<color=yellow>Ammo: 8/120",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/tt icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/tt_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/tt_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/tt_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/tt.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/tt_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.15f, 0.12f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/tt sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62x25mm TT";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.57f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.57f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.094f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Enfield No.2 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "No need to think that the British military without exception went with revolvers, no... they went with English revolvers. \n<color=yellow>Ammo: 6/120",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/enfield icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/enfield_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/enfield.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 6;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/enfield_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.EjectShells = false;
                      firearm.barrelPosition = new Vector2(0.19f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/enfield sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".380' Revolver Mk1";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.55f;
                      customCartridge.ImpactForce = 0.75f;
                      customCartridge.StartSpeed = 3.7f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.55f;
                        customCartridge.ImpactForce = 0.75f;
                        customCartridge.StartSpeed = 3.7f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 0.3s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");
                        Ammo.FireRate = 0.3f;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.55f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.086f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Welrod <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Silent pistol of British intelligence. Looks like on one time. \n<color=yellow>Ammo: 6/60",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/welrod icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/welrod_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/welrod_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/welrod_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/welrod.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 6;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/welrod_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.35f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/welrod sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.7f;
                      customCartridge.StartSpeed = 3f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.7f;
                        customCartridge.StartSpeed = 3f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 1s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");
                        Ammo.FireRate = 1f;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.12f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Dreyse M1907 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A pistol that looks like an elephant or a hair dryer. \n<color=yellow>Ammo: 7/175",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/dreyse icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/dreyse_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/dreyse_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/dreyse_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/dreyse.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/dreyse_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.13f, 0.14f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/dreyse sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62x17mm";
                      customCartridge.Damage = 11.5f;
                      customCartridge.Recoil = 0.6f;
                      customCartridge.ImpactForce = 0.65f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.6f;
                        customCartridge.ImpactForce = 0.65f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.6f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.8f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Grenade Launcher"),
                  NameOverride = "Kampf Pistole <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "How to convert a signal pistol into a grenade launcher? - ask the Germans how! \n<color=yellow>Ammo: 1/5",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/kampf_pistole icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                      ModAPI.KeepExtraObjects();

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/kampf_pistole_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      var firearm = Instance.GetComponent<ProjectileLauncherBehaviour>();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/kampf_pistole.png", 2);
                      Instance.GetComponent<SpriteRenderer>().sortingOrder = 1;
                      firearm.projectileAsset = ModAPI.FindSpawnable("Kampf Grenaden <color=#000000>megaturn</color>");
                      firearm.projectileLaunchStrength = 0.35f;

                      firearm.launchSound = ModAPI.LoadSound("Sounds/kampf_pistole sound.mp3");
                      firearm.barrelPosition = new Vector2(0.03f, 0.04f);
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
         );

         ModAPI.Register(
             new Modification()
             {
                 OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                 NameOverride = "Kampf Grenaden <color=#000000>megaturn</color>",
                 NameToOrderByOverride = "A - FA",
                 DescriptionOverride = "",
                 CategoryOverride = ModAPI.FindCategory(""),
                 ThumbnailOverride = ModAPI.LoadSprite(""),
                 AfterSpawn = (Instance) =>
                 {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/kampf_grenaden.png", 2);

                     Instance.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                     Instance.GetComponent<ExplosiveBehaviour>().Range = 5f;
                     Instance.GetComponent<ExplosiveBehaviour>().ExplodeBurnProgressThreshold = 2f;
                     Instance.GetComponent<ExplosiveBehaviour>().ImpactForceThreshold = 0.5f;
                     Instance.GetComponent<ExplosiveBehaviour>().BurnPower = 0f;
                     Instance.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 10f;
                     Instance.FixColliders();
                     Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                 }
             }
         );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Luger <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Very accurate, ergonomic, powerful and compact, but expensive pistol. \n<color=yellow>Ammo: 8/160",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/luger icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/luger_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/luger_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/luger_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/luger.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/luger_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.15f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/luger sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.45f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.45f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.45f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Mauser <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "The German multi-seat pistol was used as the SG. You can switch the fire mode. \n<color=yellow>Ammo: 10/200",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mauser icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/mauser_mp_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/mauser_mp_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/mauser_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/mauser.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 10;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mauser_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.29f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mauser sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,63x25mm Mauser";
                      customCartridge.Damage = 11.5f;
                      customCartridge.Recoil = 0.45f;
                      customCartridge.ImpactForce = 0.62f;
                      customCartridge.StartSpeed = 4.5f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.45f;
                        customCartridge.ImpactForce = 0.62f;
                        customCartridge.StartSpeed = 4.5f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=orange>Switch to Auto</color>", "<color=orange>Make it an SG with the ability to shoot bursts.\n<color=yellow>Ammo: 10/200", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.45f;
                        customCartridge.ImpactForce = 0.62f;
                        customCartridge.StartSpeed = 4.5f;
          							Ammo.FireRate = 0.143f;
          							Ammo.Auto = true;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.45f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.095f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Mauser MP <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Pistol stock = +100 accuracy. \n<color=yellow>Ammo: 10/200",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mauser_mp icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/mauser_mp_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/mauser_mp_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/mauser_mp_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/mauser_mp.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 10;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mauser_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.29f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mauser sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,63x25mm Mauser";
                      customCartridge.Damage = 11.5f;
                      customCartridge.Recoil = 0.45f;
                      customCartridge.ImpactForce = 0.62f;
                      customCartridge.StartSpeed = 4.5f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.45f;
                        customCartridge.ImpactForce = 0.62f;
                        customCartridge.StartSpeed = 4.5f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("auto shooting", "<color=orange>Switch to Auto</color>", "<color=orange>Make it an SG with the ability to shoot bursts.\n<color=yellow>Ammo: 10/200", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.45f;
                        customCartridge.ImpactForce = 0.62f;
                        customCartridge.StartSpeed = 4.5f;
          							Ammo.FireRate = 0.143f;
          							Ammo.Auto = true;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.45f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.125f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Mauser HSc <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "An ultra-compact pistol from the supernation. \n<color=yellow>Ammo: 8/160",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/mauser_hsc icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/mauser_hsc_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/mauser_hsc_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/mauser_hsc_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/mauser_hsc.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/mauser_hsc_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.08f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/mauser_hsc sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = ".32 ACP";
                      customCartridge.Damage = 10f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.5f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.5f;
                        customCartridge.StartSpeed = 4f;
                        Ammo.FireRate = 0.0001f;
                        Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.08f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Walter <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Ersatz version of the more expensive Luger. \n<color=yellow>Ammo: 8/160",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/walter icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/walter_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/walter_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/walter_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/walter.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/walter_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.20f, 0.105f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/walter sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.094f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Nambu <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "An analogue of an unknown German pistol in the expanses of the land of the rising sun. \n<color=yellow>Ammo: 8/160",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/nambu icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/nambu_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/nambu_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/nambu_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/nambu.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/nambu_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.14f, 0.095f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/nambu sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "8x22mm Nambu";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.72f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.72f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.08f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Nambu Type 94 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Cumbersome, inaccurate, and be aware that you, as a Japanese officer, had to put in your own money for it. \n<color=yellow>Ammo: 6/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/nambu94 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/nambu94_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/nambu94_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/nambu94_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/nambu94.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 6;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/nambu94_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.21f, 0.125f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/type94 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "8x22mm";
                      customCartridge.Damage = 10.5f;
                      customCartridge.Recoil = 0.7f;
                      customCartridge.ImpactForce = 0.75f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10.5f;
                        customCartridge.Recoil = 0.7f;
                        customCartridge.ImpactForce = 0.75f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.7f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.078f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Type 26 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "It's funny that Japanese revolvers are no different from Japanese pistols in terms of the number of rounds. \n<color=yellow>Ammo: 6/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/type26 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/type26_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/type26.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 6;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/type26_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.EjectShells = false;
                      firearm.barrelPosition = new Vector2(0.23f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/type26 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9x22mm R";
                      customCartridge.Damage = 11.5f;
                      customCartridge.Recoil = 0.55f;
                      customCartridge.ImpactForce = 0.85f;
                      customCartridge.StartSpeed = 3.7f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.55f;
                        customCartridge.ImpactForce = 0.85f;
                        customCartridge.StartSpeed = 3.7f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("cooldown", "<color=#3D81FF>Cooldown Mode</color>", "<color=#3D81FF>Makes the weapon cooldown. (if you want more realism)</color>\n Cooldown: 0.3s", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=#3D81FF>Switched Cooldown</color>");
                        Ammo.FireRate = 0.3f;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.55f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Beretta 34 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Like any other Beretta only version 34. \n<color=yellow>Ammo: 6/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/beretta icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/beretta_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/beretta_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/beretta_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/beretta.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/beretta_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.12f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/beretta34 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9x17mm";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.075f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                  NameOverride = "Glisenti M1910 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Glisenti is translated from Italian as we completely stole the concept from the Germans not wanting to pay them for a license. \n<color=yellow>Ammo: 6/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/glisentia icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/glisentia_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                      ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/glisentia_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/glisentia_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/glisentia.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/glisentia_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.12f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/glisentia sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9x19mm Glisenti";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.082f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Astra 600 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "The alien design distinguishes the pistol from others and is called <<astro pistol>>. \n<color=yellow>Ammo: 8/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/astra600 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/astra600_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/astra600_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/astra600_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/astra600.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/astra600_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.18f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/astra600 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Parabellum";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.57f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.57f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.57f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.108f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "CZ Mod.27 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "Like Japanese weapons can be recognized through the word <<type>>, so the Czech one can be recognized by the letters <<cz>>. \n<color=yellow>Ammo: 8/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/cz27 icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/cz27_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/cz27_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/cz27_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/cz27.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 8;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/cz27_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.12f, 0.105f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/cz27 sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "7,62x17mm Browning";
                      customCartridge.Damage = 11.5f;
                      customCartridge.Recoil = 0.55f;
                      customCartridge.ImpactForce = 0.65f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 11.5f;
                        customCartridge.Recoil = 0.55f;
                        customCartridge.ImpactForce = 0.65f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.55f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.075f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Frommerstop <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A gun ahead of its time... in appearance. \n<color=yellow>Ammo: 7/175",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/frommerstop icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/frommerstop_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/frommerstop_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/frommerstop_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/frommerstop.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 7;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/frommerstop_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.135f, 0.09f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/frommerstop sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "9mm Kurz";
                      customCartridge.Damage = 9.5f;
                      customCartridge.Recoil = 0.55f;
                      customCartridge.ImpactForce = 0.81f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 9.5f;
                        customCartridge.Recoil = 0.55f;
                        customCartridge.ImpactForce = 0.81f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.55f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.07f;
                  }
              }
          );

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Roth-Steyr M1907 <color=#000000>megaturn</color>",
                  NameToOrderByOverride = "A - FA",
                  DescriptionOverride = "A portal to hell opened in Austria-Hungary and this thing came out. \n<color=yellow>Ammo: 10/180",
                  CategoryOverride = ModAPI.FindCategory("WWII <color=yellow>Pistols</color>"),
                  ThumbnailOverride = ModAPI.LoadSprite("Icons/steyr icon.png"),
                  AfterSpawn = (Instance) =>
                  {
                    var Weapon = Instance.transform;
                    var Cover = new GameObject("Cover");
                    Cover.transform.SetParent(Weapon);
                    Cover.transform.localPosition = new Vector3(0f, 0f);
                    Cover.transform.rotation = Weapon.rotation;
                    Cover.transform.localScale = new Vector3(1f, 1f);
                    var CoverSprite = Cover.AddComponent<SpriteRenderer>();
                    CoverSprite.sprite = ModAPI.LoadSprite("Pistols/steyr_cover.png", 2);
                    CoverSprite.sortingOrder = 7;

                    ModAPI.KeepExtraObjects();

                      var PistolSlide = Instance.transform.Find("Slide");
                      PistolSlide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/steyr_slide.png", 2);

                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Colliders/steyr_collider.png", 24);
                      foreach (var c in Instance.GetComponents<Collider2D>())
                      {
                          GameObject.Destroy(c);
                      }
                      Instance.FixColliders();
                      Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Pistols/steyr.png", 2);

                      Instance.AddComponent<AmmoBehaviour>();
                      var Ammo = Instance.GetComponent<AmmoBehaviour>();
                      Ammo.TrueMaxAmmo = 10;
                      Ammo.ReloadSound.clip = ModAPI.LoadSound("Sounds/Reloads/steyr_reload sound.mp3");

                      var firearm = Instance.GetComponent<FirearmBehaviour>();
                      firearm.BulletsPerShot = 1;
                      firearm.barrelPosition = new Vector2(0.17f, 0.11f);
                      firearm.ShotSounds = new AudioClip[]
                      {
                            ModAPI.LoadSound("Sounds/steyr sound.mp3"),
                      };

                      Cartridge customCartridge = ModAPI.FindCartridge("9mm");
                      customCartridge.name = "8x19mm Roth";
                      customCartridge.Damage = 10f;
                      customCartridge.Recoil = 0.5f;
                      customCartridge.ImpactForce = 0.68f;
                      customCartridge.StartSpeed = 4f;
                      firearm.Cartridge = customCartridge;

                      Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("semi-auto", "<color=red>Reset Gun</color>", "<color=red>Reset gun back to factory settings.", new UnityAction[1]
                      {
                        (UnityAction) (() =>
                      {

                        ModAPI.Notify("<color=red>Switched to Semi-auto</color>");

                        firearm.BulletsPerShot = 1;
                        customCartridge.Damage = 10f;
                        customCartridge.Recoil = 0.5f;
                        customCartridge.ImpactForce = 0.68f;
                        customCartridge.StartSpeed = 4f;
          							Ammo.FireRate = 0.0001f;
          							Ammo.Auto = false;
                      })
                      }));

                  Instance.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("traumatic", "<color=green>Traumatic Bullets</color>", "<color=green>Bullets designed to maim, not kill - have relatively strong knockback but non-lethal damage (except for the head).", new UnityAction[1]
                  {
                    (UnityAction) (() =>
                  {

                    ModAPI.Notify("<color=green>Switched to Traumatic</color>");
                    ModAPI.Notify("<color=green>Don't shoot to the head!</color>");

                    firearm.BulletsPerShot = 1;
                    customCartridge.Damage = 0.0f;
                    customCartridge.Recoil = 0.5f;
                    customCartridge.ImpactForce = 16f;
                    customCartridge.StartSpeed = 0.05f;
                    Ammo.FireRate = 0.0001f;
                    Ammo.Auto = false;
                  })
                  }));

                      var phys = Instance.GetComponent<PhysicalBehaviour>();
                      Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.099f;
                  }
              }
          );
        }
    }
}
